destroyed = 0
SpellLevel = 0
Rank = 0
Army = 14
Titan = 30

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	AddTargetCircleWithArrow("vfx1")
	
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_6")
	GiveDefenderSpoil("H_448")
	GiveDefenderSpoil("H_18")
	
	SetTriggerCallbacks("trigger1", trigger1enter_onTriggerEnter)
	SetTriggerCallbacks("trigger2", trigger2enter_onTriggerEnter)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1.0, framecamera)
	end
end

function framecamera(seconds)
    FrameCamera("camera")
	AddTimer(0.5, talkingHead1)
	AddTimer(5.5, removeText)
	AddTimer(6.0, ReturnCamera)
	AddTimer(7.0, talkingHead2)
	AddTimer(12.0, removeText)
	AddTimer(13.0, revealUI)
	EnableCameraControl(false)
end

function talkingHead1()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_UNAKADVENTURELEVEL3_1","BOTTOM_LEFT")
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_UNAKADVENTURELEVEL3_2","BOTTOM_LEFT")
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	EnableCameraControl(true)
end

function removeText()
	HideDialog()
end

function trigger1enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.1, spawnVfx1)
		DisableTrigger("trigger1")
	end
end

function trigger2enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.1, spawnVfx2)
		DisableTrigger("trigger2")
	end
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx2wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx3wave1")
	AddTimer(1.0, spawnwave1)
	
end

function spawnVfx2()

	PlayVFX("PA_SpawnReinforcement", "vfx1wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx2wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx3wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	AddTimer(1.0, spawnwave2)
	
end

function spawnwave1()

	SpawnUnits("wave1",Army)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	SpawnUnits("Titan",Titan)
	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 15 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("Titan",Titan)
	end
	
end





