destroyed = 0
SpellLevel = 0
Rank = 0
Army = 20
Titan = 40

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	AddTargetCircleWithArrow("vfx11")
	
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_380_10")
	GiveDefenderSpoil("H_381_10")
	GiveDefenderSpoil("EV_185_10")
	GiveDefenderSpoil("H_382_10")
	GiveDefenderSpoil("H_383_10")
	
	SetTriggerCallbacks("trigger1", trigger1enter_onTriggerEnter)
	SetTriggerCallbacks("trigger2", trigger2enter_onTriggerEnter)
	SetTriggerCallbacks("trigger3", trigger3enter_onTriggerEnter)
	SetTriggerCallbacks("trigger4", trigger4enter_onTriggerEnter)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1.0, framecamera)
	end
end

function framecamera(seconds)
    FrameCamera("camera")
	AddTimer(0.5, talkingHead1)
	AddTimer(5.5, removeText)
	AddTimer(6.0, ReturnCamera)
	AddTimer(7.0, talkingHead2)
	AddTimer(12.0, removeText)
	AddTimer(13.0, revealUI)
	EnableCameraControl(false)
end

function talkingHead1()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL6_1","BOTTOM_LEFT")
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL6_2","BOTTOM_LEFT")
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	EnableCameraControl(true)
end

function removeText()
	HideDialog()
end

function trigger1enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(3.5, spawnVfx1)
		AddTimer(0.1, fireball1)
		DisableTrigger("trigger1")
	end
end

function fireball1()

	CastSpell("Fireball", 1, "fireball1",0)
	CastSpell("Fireball", 1, "fireball2",0)
	
end

function trigger2enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(3.5, spawnVfx2)
		AddTimer(0.1, fireball2)
		DisableTrigger("trigger2")
	end
end

function fireball2()

	CastSpell("Fireball", 1, "fireball3",0)
	CastSpell("Fireball", 1, "fireball4",0)
	
end

function trigger3enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(3.5, spawnVfx3)
		AddTimer(0.1, fireball3)
		DisableTrigger("trigger3")
	end
end

function fireball3()

	CastSpell("Fireball", 1, "fireball5",0)
	CastSpell("Fireball", 1, "fireball6",0)
	
end

function trigger4enter_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.5, spawnVfx4)
		DisableTrigger("trigger4")
	end
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	AddTimer(1.0, spawnwave1)
	
end

function spawnVfx2()

	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	AddTimer(1.0, spawnwave2)
	
end

function spawnVfx3()

	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawnwave3)
	
end

function spawnVfx4()

	PlayVFX("PA_SpawnReinforcement", "vfx7")
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	PlayVFX("PA_SpawnReinforcement", "vfx9")
	PlayVFX("PA_SpawnReinforcement", "vfx10")
	PlayVFX("PA_SpawnReinforcement", "vfx11")
	AddTimer(1.0, spawnwave4)
	
end

function spawnwave1()

	SpawnUnits("wave1",Army)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	
end

function spawnwave3()

	SpawnUnits("wave3",Army)
	
end

function spawnwave4()

	SpawnUnits("wave4",Army)
	SpawnUnits("Titan",Titan)
	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 21 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
		SpawnUnits("Titan",Titan)
	end
	
end










