
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

-- no units alive at start of game so winnable set to false
function onDeployStart()
	SetMultipleUnitSelectionButtonEnabled(false)
  SetStandGuardButtonEnabled(false)
  inDeploy = true
  SetMultipleUnitSelectionButtonEnabled(false)
  SetAutoOrdersButtonEnabled(false)
  DisableNecromancer(true)
  SpawnUnits("MilitiaCentre")
  
  --SetCamera(-50, 0, -200, 0, -250) -- focusX, focusY, zoom, heading, pitch / focusX, focusY, ficusZ, angle, zoom

  if HasBattleBeenRestarted() then
    ShowDialogInPosition("talkingheads/full/guard","TXT_SP1A_BATTLE_RESTARTED","BOTTOM_LEFT")
    orderGiven = true -- Don't need to re-do the tutorial parts
	shouldPlayTapUnitMovie = false
  else
    EnableSelectionChange(false) -- Don't allow player to select unit before the popup
    SetFightButtonEnabled(false)
  end
end

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	SetVictoryBarEnabled(false)
	SetPanningCamera(18.5, -115.7, 49.8, 0.0, -0.46) -- focusX, focusY, zoom, heading, pitc
	SetStandGuardButtonEnabled(false)
	SetWinnable(false)
end

function removeText()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 3 then
			Army = 1
		elseif Rank >= 4 then
			Army = Rank -2
		end
    if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
        SpawnUnits("titan")
		SpawnUnits("spawn")
		SpawnUnits("spawn1")
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" and not orderGiven then
   -- ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE2_BATTLE_1A","BOTTOM_LEFT")
    ShowDialogInPosition("talkingheads/full/guard","TXT_SP2A_BATTLE_NEW","BOTTOM_LEFT")
	AddTimer(1.0, selectArcher)
    EnableSelectionChange(true)
  end

  
	if cameraName == "BATTLE_START" then

	end
end



function selectArcher ()

	local allies = GetUnits("*", "Archer*", 0) -- get player titan
	if allies[1] then 
		PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
	end
end


function onUnitSelected(unit)
	if unit.attacker and not orderGiven then
		shouldPlayTapUnitMovie = false
		CloseTutorialMovie()
		--HideDialog()
		--ShowDialogInPosition("talkingheads/full/generictitan","TXT_FTUE_STORY_INFO2","BOTTOM_LEFT")
		
		--AddTimer(0.1, PlayTutorialMovieOnUnit, "Media/UI/Tutorial_UnitCommands02.swf", unit)
		EnableSelectionChange(false)
		waitingForOrder = true
		titanselect = 1
		AddTimer(0.5, tapEnemy)
		--AddTimer(15.0, moveTitan)
	end
end

function tapEnemy ()

	ShowDialogInPosition("talkingheads/full/guard","TXT_INTRO_TEXT_3","BOTTOM_LEFT")
	

	local allies = GetUnits("MilitiaCentre", "*", 1) -- get player Militia unit
	PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
	

end


function onUnitDestroyed(unit)
	CloseTutorialMovie()
end

function onUnitOrderGiven(unit, orderType)
  if inDeploy and waitingForOrder then
    waitingForOrder = false
    orderGiven = true
    CloseTutorialMovie()
    EnableSelectionChange(true)
	AddTimer(1.0, frameCam)
    AddTimer(1.0, function()
		--HideDialog()
        --ShowDialog("talkingheads/full/guard","TXT_SP1A_GIVE_ORDER_OK")
		ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_FIGHT","BOTTOM_LEFT")
		AddTimer(5.0, removeText)
    end)
    AddTimer(1.0, SetFightButtonEnabled, true)
  end
end


function frameCam ()

	FrameCamera("cam")

end

function showFightButton()

	SetFightButtonEnabled(true)

end


function onTalkingHeadFinish(text)
	if text == "TXT_FTUE2_BATTLE_4A" then
		SetFightButtonEnabled(true)
	end
	if text == "TXT_FTUE2_BATTLE_4D" then
		--endit()
	end
end


-- counts the number of dead units, sets the win condition back to true when 8 enemies have been killed
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed +1
		if destroyed == 2 then
			PlayVFX("PA_SpawnReinforcement", "pos3")  --PA_CameraSpawnReinforcemen
			AddTimer(1.0, SpawnUnits, "titan") 
			AddTimer(0.1,framecamera)
			AddTimer(1.0, ShowDialogInPosition, "talkingheads/full/Tewin","TXT_FTUE2_BATTLE_4B","BOTTOM_RIGHT")
			AddTimer(6.0, HideDialog)
			AddTimer(6.2, Text)
		end
		if destroyed == 3 then
			ShowDialogInPosition("talkingheads/full/Tewin","TXT_FTUE2_BATTLE_4D","BOTTOM_RIGHT")
			SetWinnable(true)
			Win()
		end
	end
end

function Text()
    ShowDialogInPosition("talkingheads/full/knight","TXT_FTUE2_BATTLE_4C","BOTTOM_RIGHT")
    AddTimer(6.0, HideDialog)
end

function framecamera(seconds)
    FrameCamera("pos1")
    EnableCameraControl(true)
    AddTimer(4.0,ReturnCamera)
end


function endit()
	Win()
end
