
function onDeployStart()
	ShowMessageBox("Welcome", "My liege, the enemy appear to have sent but a single unit of laughable prowess.")
end

function onLevelStart()

  --
  local units = GetUnits("*", "*") -- spawnId filter, optional unit type filter, optional side (0=human attacker, 1=AI defender)
	for i,unit in pairs(units) do
	  print("UNIT AT START", i, ":", unit);
	  if unit.side==1 and unit.id=="Militia" then
	    print("STAND GROUND:", unit);
	    SetUnitStandGuard(unit, true)
	  end
	end

  -- Disable normal timer
  -- To re-add a normal time-out, do something like:
  --    AddVisualTimer(10, Lose);
  SetDisplayTimer(0,0)
  
  -- Don't win by default when all defenders destroyed
  SetWinnable(false)
  
	-- Automatic string of dialog boxes. Important note: script execution carries on!
	ShowMessageBoxes(
		"Testing 1 2 3", "This is a test dialog", 
		"Testing some more", "Patronising tutorial message goes here?", 
		"And finally...", "Some more text..."
		)
	
	-- Timer which calls a level-specific function
	local t = 15.0;
	AddTimer(t, ambushTimer)

	SetDisplayTimer(t, 0); -- Visible countdown timer
	
	--SetDisplayTimer(0, t); -- Visible countup timer
	
	-- Can also pass parameters through to timer called functions like this:
	testTimer = AddTimer(3.0, ShowDialog, "timer3", "This is a popup at the 3 second mark")
	
	CancelTimer(testTimer)
	
	SetTriggerCallbacks("trigger1", onTrigger1)
	SetTriggerCallbacks("trigger2", onTrigger2, onTrigger2Leave)
end

function endswith(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end

function onUnitDestroyed(unit)
	print("unit destroyed: " .. unit.id .. " " .. (unit.attacker and "Attacker" or "Defender") .. " SpawnID:" .. unit.spawnId)
	if endswith(unit.spawnId, "_respawn") then
	  RespawnUnits(unit.spawnId);
	end
end

function onTrigger1(unit)
	print("trigger 1 entered by " .. unit.id .. " " .. (unit.attacker and "Attacker" or "Defender"))
	if unit.defender then
		ShowDialog("Defender", "defender entered trigger1")
	end
end

function onTrigger2(unit)
	print("trigger 2 entered by " .. unit.id .. " " .. (unit.attacker and "Attacker" or "Defender"))
end

function onTrigger2Leave(unit)
	print("trigger 2 left by " .. unit.id .. " " .. (unit.attacker and "Attacker" or "Defender"))
	if unit.attacker then
		ShowDialog("bye bye", "attacker leaving trigger2")
		DisableTrigger("trigger2")
	end
end

function onDefenderDestroyed()
	-- Make sure the player can't actually win until they've killed everything
  SetDisplayTimer(0,0)
	if CountSpawnUnits("*") > 0 then
		AddTimer(2.0, function()
			ambushTimer() -- Spawn the archers if they're not already around
			SpawnUnits("*") -- Spawn anything else
		end)
	else
	  -- Nothing left to spawn, so the player wins
	  Win()
	end
end

function ambushTimer()
  SetDisplayTimer(0,0)
  
	-- SpawnUnits can be given strings with * as a wildcard.
	-- So SpawnUnits("*") will spawn all remaining unspawned units
	local numberOfUnitsSpawned = SpawnUnits("archer*")
	
	if numberOfUnitsSpawned > 0 then
		-- Single dialog box with a callback when the user dismisses it
		ShowDialog("Surprise!", "Some archers suddenly appear!", afterAmbushDialog)
	end
	
	local units = GetUnits("archer*", "*", 1) -- spawnId filter, unit type filter, side (0=human attacker, 1=AI defender)
	for i,unit in pairs(units) do
	  print("STAND GROUND:", unit);
	  SetUnitStandGuard(unit, true)
	end
end

function afterAmbushDialog()
	ShowDialog("Good luck", "blah blah")
end

