-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 35
Army = 14
Army1 = 13
Army2 = 12

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
		
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	ShowDialogInPosition("talkingheads/full/guard","TXT_SP21_1","BOTTOM_LEFT")
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	AddTargetCircle("runArea")
	--AddTimer(6.0, removehighlight)
end

-- called after the deploy phase
function onLevelStart()
	SetVictoryBarEnabled(false)
	DisableAiSpells()
	AddTimer(7.0, randomUnits)
	SetTriggerCallbacks("lossArea", enter_onTriggerEnter, enter_onTriggerLeave)
	removehighlight()
	--cast = 1
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function triggercheck()
	local var1 = CountDefendersInTrigger("lossArea")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true
		AddTimer(3.0, triggercheck2)
	end 
	--Success()
	
end

function triggercheck2()
	local var1 = CountDefendersInTrigger("lossArea")
	if var1 == 1 then 
		ShowDialogInPosition("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_3_LOSE","BOTTOM_LEFT")
		Lose()
	elseif var1 > 0 then
		triggercheck()
	end 
	--Success()
	
end

function enter_onTriggerEnter(unit)
	triggercheck()
end

function randomUnits()
	SetVictoryBarEnabled(true)
	SetupVictoryBar()
	SetVictoryBarFill(0)
	SpawnUnits("Spawn1",Army)
	AddTimer(20.0, randomUnits1)
end

function randomUnits1()
	SpawnUnits("Skeleton1",Army)
	AddTimer(20.0, randomUnits2)
end

function randomUnits2()
	SpawnUnits("Spawn3Moss",Army)
	AddTimer(20.0, randomUnits3)
end

function randomUnits3()
	SpawnUnits("Spawn4",Army)
	AddTimer(20.0, randomUnits4)
end

function randomUnits4()
	SpawnUnits("Spawn7",Army)
	AddTimer(20.0, spawnTitan)
end

function spawnTitan()
	SpawnUnits("Titan",Titan)
end

function removehighlight()
	ClearTargetCircles()
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function findText()
	AddTimer(1.0, findText)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			SetVictoryBarFill(3/21)
		end
		if destroyed == 9 then
			SetVictoryBarFill(9/21)
		end
		if destroyed == 13 then
			SetVictoryBarFill(13/21)
		end
		if destroyed == 15 then
			SetVictoryBarFill(15/21)
		end
		if destroyed == 18 then
			SetVictoryBarFill(18/21)
		end
		if destroyed == 21 then
			SetVictoryBarFill(1.0)
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("Spawn1",Army)
		SpawnUnits("Skeleton1",Army)
		SpawnUnits("Spawn3Moss",Army)
		SpawnUnits("Spawn4",Army)
		SpawnUnits("Spawn7",Army)
	end			
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/21)
	AddVictoryBarMarker(9/21)
	AddVictoryBarMarker(13/21)
	AddVictoryBarMarker(15/21)
	AddVictoryBarMarker(18/21)
	AddVictoryBarMarker(1.0)
end
