-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 14
Army = 6

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SpawnUnits("Titan",Titan)
	AddTimer(4.5, framecamera)
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(8.0, enableControls)
end

function framecamera()
	FrameCamera("camera1")
	ShowDialogInPosition("talkingheads/full/guard","TXT_TITLE_FIGHTDES_CAMPAIGN9C_2","BOTTOM_LEFT")
	AddTimer(4.0, ReturnCamera)
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("spawnWave1", enter_onTriggerEnterWave1)
	SetTriggerCallbacks("spawnWave2", enter_onTriggerEnterWave2)
	SetTriggerCallbacks("spawnWave3", enter_onTriggerEnterWave3)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnterWave1(unit)
	if unit.attacker then
	SpawnUnits("Wave1",Army)
	DisableTrigger("spawnWave1")
	end
end

function enter_onTriggerEnterWave2(unit)
	if unit.attacker then
	SpawnUnits("Wave2",Army)
	DisableTrigger("spawnWave2")
	end
end

function enter_onTriggerEnterWave3(unit)
	if unit.attacker then
	SpawnUnits("Wave3",Army)
	DisableTrigger("spawnWave3")
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 20 then
			Win()
		end
	end
end

function spawnFinalWave()
	SpawnUnits("FinalWave",Army)
end

function moveOrder()
	GiveNamedUnitMoveOrder("FinalWave","claim")	
	GiveNamedUnitMoveOrder("Titan","claim")	
end


function createStartingTroops(forPlinthInspector)
	--SpawnUnits("Wall")
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("Wave1",Army)
		SpawnUnits("Wave2",Army)
		SpawnUnits("Wave3",Army)
		SpawnUnits("FinalWave",Army)
	end
end
