-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 18
Army = 8
Army1 = 7

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function onDeployStart()
	ShowDialogInPosition("talkingheads/full/guard","TXT_DAILY_BATTLEORDER_VILLAGE_3","BOTTOM_LEFT")
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("SkeletonStart",Army1)
	SpawnUnits("Pikeman",Army)
end



-- called after the deploy phase
function onLevelStart()
	SpawnUnits("Skeleton",Army)
	AddTimer(34.0, spawnUnak)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
	SetupVictoryBar()
	SetVictoryBarFill(0)
end

function spawnUnak()
	--ShowDialogInPosition("talkingheads/full/guard","More soldiers are appearing from their army camps.*","TOP_LEFT")
	SpawnUnits("unakLeft",Army1)
	SpawnUnits("unakRight",Army1)
	AddTimer(2.0, unakMove)
end

function unakMove()
	--GiveNamedUnitMoveOrder("unakLeft","left1")	
	--GiveNamedUnitMoveOrder("unakRight","right1")	
	AddTimer(20.0, spawnMilitia)
end

function spawnMilitia()
	--ShowDialogInPosition("talkingheads/full/guard","They're amassing a large army, get ready!.*","TOP_LEFT")
	SpawnUnits("militiaLeft",Army)
	SpawnUnits("militiaRight",Army)
	AddTimer(2.0, militiaMove)
end

function militiaMove()
	--GiveNamedUnitMoveOrder("militiaLeft","left2")	
	--GiveNamedUnitMoveOrder("militiaRight","right2")	
	AddTimer(1.0, ragnarVFX)
	AddTimer(2.0, ragnarWave)
end

function ragnarVFX()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
end

function ragnarWave()
	SpawnUnits("ragnarLeft",Army)
	SpawnUnits("ragnarRight",Army)	
	AddTimer(9.0, titanVFX)
	AddTimer(7.0, titanWave)
end

function titanVFX()
	PlayVFX("PA_SpawnReinforcement", "vfx2")
end

function titanWave()
	SpawnUnits("titan",Titan)
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 then
			SpawnUnits("Skeleton2",Army)
		end
		if destroyed == 4 then
			SetVictoryBarFill(4/18)
		end
		if destroyed == 7 then
			SetVictoryBarFill(7/18)
		end
		if destroyed == 9 then
			SetVictoryBarFill(9/18)
		end
		if destroyed == 13 then
			SetVictoryBarFill(13/18)
		end
		if destroyed == 18 then
			SetVictoryBarFill(1.0)
			Win()
		end
	end
end

function moveOrder()
	--GiveNamedUnitMoveOrder("FinalWave","claim")	
	--GiveNamedUnitMoveOrder("Titan","claim")	
end


function createStartingTroops(forPlinthInspector)
	--SpawnUnits("Wall")
	if forPlinthInspector then
		SpawnUnits("SkeletonStart",Army1)
		SpawnUnits("Pikeman",Army)
		SpawnUnits("Skeleton",Army)
		SpawnUnits("Skeleton2",Army)
		SpawnUnits("unakLeft",Army1)
		SpawnUnits("unakRight",Army1)
		SpawnUnits("ragnarLeft",Army)
		SpawnUnits("ragnarRight",Army)	
		SpawnUnits("titan",Titan)
	end
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(4/18)
	AddVictoryBarMarker(7/18)
	AddVictoryBarMarker(9/18)
	AddVictoryBarMarker(13/18)
	AddVictoryBarMarker(1.0)
end
