
-- Global variables, sets variables for the skeletons to appear.
spawnCounter = 0
spawnTurn = 0
SpellLevel = 0
Army = 0
Titan = 0
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

--deploy phase, sets the initial 2 talking heads to set the scene
function onDeployStart()
 	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(12.5, unlockbuttons)
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	createStartingTroops(False)
	PlayVFX("ElderStone_EnergyProp", "stone")
	PlayVFX("ElderStone_EnergyPropStones", "stone1")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyPropStones", "stone3")
	PlayVFX("ElderStone_EnergyPropStones", "stone4")
	PlayVFX("ElderStone_EnergyPropStones", "stone5")
	PlayVFX("ElderStone_EnergyPropStones", "stone6")
	PlayVFX("ElderStone_EnergyPropStones", "stone7")
	PlayVFX("ElderStone_EnergyPropStones", "stone8")
	PlayVFX("ElderStone_EnergyPropStones", "stone9")
	PlayVFX("ElderStone_EnergyPropStones", "stone10")
	
	local units = GetUnits("Leader", "Leader", 1)
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
	end	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		FrameCamera("camAlmarand")
		ShowDialog("talkingheads/full/guard", "TXT_BOSS1_1")
		ShowDialog("talkingheads/full/almarand", "TXT_BOSS1_2")	
		EnableCameraControl(false)
		AddTimer(8.5, ReturnCamera)
	end
end


function unlockbuttons()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 6
	SpellLevel = 4
	Army = 7
	Army1 = 7
	Army2 = 7
	Titan = 14

	SpawnUnits("start",Army2)
	SpawnUnits("Leader",Titan)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Leader",Titan)
		SpawnUnits("start",Army2)
		SpawnUnits("start2",Army)
		SpawnUnits("skeleton1",Army)
		SpawnUnits("skeleton1",Army)
		SpawnUnits("skeleton2",Army)
		SpawnUnits("skeleton3",Army)
		SpawnUnits("skeleton4",Army)
	end
end
	
	

-- battle start
function onLevelStart()
	SetWinnable(false)
	AddTimer(8.0,SpawnLoop)
	AddTimer(15.0,reinforcements)	
	SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end	
	local units = GetUnits("Leader*", "*", 1)
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
	end	
end

function reinforcements()
	PlayVFX("PA_SpawnReinforcement", "ragnar")
	PlayVFX("PA_SpawnReinforcement", "cat")	
	AddTimer(2,reinforcmentspawns)
end

function reinforcmentspawns()
	SpawnUnits("start2",Army)
	--ShowDialog("talkingheads/full/guard", "TXT_SP16_8")	
end

-- spawns troops alternating between sides
function SpawnLoop()
 	spawnCounter = spawnCounter + 1
	if spawnTurn == 0 then
	--ShowDialog("talkingheads/full/almarand", "TXT_SP16_3")
		PlayVFX("PA_SpawnReinforcement", "impact2")	
		AddTimer(2.0, spawnme)
		spawnTurn = 1
	elseif spawnTurn == 1 then
		PlayVFX("PA_SpawnReinforcement", "impact1")
		AddTimer(2.0, spawnme2)
	--ShowDialog("talkingheads/full/almarand", "TXT_SP16_4")	
		spawnTurn = 2
	elseif spawnTurn == 2 then
		PlayVFX("PA_SpawnReinforcement", "impact3")
		AddTimer(2.0, spawnme3)
		spawnTurn = 3
	elseif spawnTurn == 3 then
		PlayVFX("PA_SpawnReinforcement", "impact4")
		AddTimer(2.0, spawnme4)
		spawnTurn = 0
	end
	
	if spawnCounter <= 8 then
		AddTimer(8.0,SpawnLoop)
	end
end


function spawnme()
	RespawnUnits("skeleton1",Army)
end

function spawnme2()
	RespawnUnits("skeleton2",Army)
end

function spawnme3()
	RespawnUnits("skeleton3",Army1)
end

function spawnme4()
	RespawnUnits("skeleton4",Army1)
	AddTimer(20.0,retreat)
end

function retreat()
	ShowDialog("talkingheads/full/guard","TXT_BOSS1_3")
	SetTriggerCallbacks("retreat", onTriggerEnter_allretreat)
	AddTargetCircle("retreatcircle")
	FrameCamera("cam_retreat")
	AddTimer(3.0, ReturnCamera)
end

function onTriggerEnter_allretreat()
	local units = GetUnits("*", "*", 0)
	for i,unit in pairs(units) do
		AddTimer(5.0,winlevel)
--		KillUnit(unit)
--		HideDeadUnit(unit)
--		Win()
	end
end

function winlevel()
	Win()
end

--[[
function finalframe()
    AddTimer(1,win)
	FrameCamera("trigger4")
end

function win()
	Win()
end

function FailCheck()
	 if dead == 4 and safe == false then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_11_10_LOSE")
		Fail()
	elseif dead == 1 and safe == false then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_11_10_ONE")
	elseif dead == 3 and safe == false then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_11_10_THREE")
	end
end

function Fail()
	Lose()
end
--]]

--[[
-- Trigger when SP16HERO dies, with delay before win condition triggers
function onUnitDestroyed(unit)
	if unit.spawnId == "Leader" then
	AddTimer(3,YouWon)	
	ShowDialog("talkingheads/full/guard", "TXT_SP16_5")	
  end
end

--End win function ends the battle once the unit has killed and time elapsed
function YouWon()
	Win()
end
--]]