Army = 1
Titan = 3
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Titan",Titan)
	SpawnUnits("wave4",Army)

	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2A_4_1")
	AddTimer(4.0, removeText)
	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("waypoint_1b", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	SetTriggerCallbacks("end", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)

	--EnableCameraControl(false)
	--EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(4.5, showTitan)
end

function onLevelStart()
	ClearTargetCircles()	
	SetWinnable(false)
	SetVictoryBarEnabled(true)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
end

function removeText()
	HideDialog()
end

function revealGroup()
 PlayVFX("PA_SpawnReinforcement", "enemy7")
 PlayVFX("PA_SpawnReinforcement", "enemy8")
 PlayVFX("PA_SpawnReinforcement", "enemy9")

 AddTimer(1.0, spawnEnemies1)
 AddTimer(1.5, revealGroup2)
 AddTimer(2.5, spawnEnemies2)
 AddTimer(2.5, revealGroup3)
 AddTimer(3.5, spawnEnemies3)

end

function revealGroup2()
 PlayVFX("PA_SpawnReinforcement", "enemy4")
 PlayVFX("PA_SpawnReinforcement", "enemy5")
 PlayVFX("PA_SpawnReinforcement", "enemy6")
 ReturnCamera()
 AddTimer(0.05, camMiddle)
end

function camMiddle()
 FrameCamera("camMiddle")
end

function revealGroup3()
 PlayVFX("PA_SpawnReinforcement", "enemy1")
 PlayVFX("PA_SpawnReinforcement", "enemy2")
 PlayVFX("PA_SpawnReinforcement", "enemy3")
 AddTimer(3.0, returnCam)
end

function spawnEnemies1()
 SpawnUnits("wave3",Army)
end

function spawnEnemies2()
 SpawnUnits("wave2",Army)
end

function spawnEnemies3()
 SpawnUnits("wave1",Army)
end

function showTitan()
	FrameCamera("titanPos")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	ShowDialogEternal("talkingheads/full/oldlady","TXT_MISSION2A_4_2")
	AddTimer(4.0, removeText)
	--ReturnCamera()
	AddTimer(2.0, revealGroup)
end

function returnCam()
	ReturnCamera()
	AddTimer(1.0, spells)
end

function spells()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION9_1_A")
	AddTargetCircle("highlight1")
	AddTargetCircle("highlight2")
	DropSpell("Fireball", 6, "spell_drop1")
	DropSpell("Fireball", 6, "spell_drop2")
	DropSpell("Fireball", 6, "spell_drop3")
	DropSpell("Fireball", 6, "spell_drop4")
	DropSpell("Fireball", 6, "spell_drop5")
	DropSpell("Fireball", 6, "spell_drop6")
	DropSpell("Fireball", 6, "spell_drop7")
	DropSpell("Fireball", 6, "spell_drop8")
	AddTimer(3.0, EnableControls)
	AddTimer(4.0, removeText)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 11 then
		   Win()
		end
	end
end


