Army = 1
Army1 = 2
destroyed = 0

escortDead = false
escortComplete = false

function onDeployStart()
	SpawnUnits("Enemy",Army)
	SetTriggerCallbacks("loss", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)
	SetTriggerCallbacks("flankLeft", onTriggerEnter_flankLeft, onTriggerLeave_flankLeft)
	SetTriggerCallbacks("flankRight", onTriggerEnter_flankRight, onTriggerLeave_flankRight)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(4.5, showVillage)
end

function onLevelStart()
	AddTimer(35.0, moveEnemy)
	--ClearTargetCircles()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
	AddTimer(10.0, spawnWaveOne)
end

function spawnWaveOne()
	SpawnUnits("wave1",Army)
end

function moveEnemy()
	GiveNamedUnitMoveOrder("Enemy", "loss")
	AddTimer(5.0, moveEnemy)
end

function onTriggerEnter_End_Zone(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
	end
end

function onTriggerEnter_flankLeft(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_3")
		DisableTrigger("flankLeft")
		DisableTrigger("flankRight")
	end
end

function onTriggerEnter_flankRight(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_3")
		DisableTrigger("flankLeft")
		DisableTrigger("flankRight")
	end
end

function showVillage()
	FrameCamera("cam")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3A_2_1")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTargetCircle("loss")
	AddTimer(4.0, returnCam)
	AddTimer(4.0, removeText)
end

function returnCam()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3A_2_2")
	ReturnCamera()
	AddTimer(3.0, EnableControls)
	AddTimer(3.0, removeText)
end

function removeText()
	HideDialog()
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("wave1",Army)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			Win()
		end
	end
end


