SpellLevel = 0
Rank = 0
destroyed = 0
Army = 2
Army1 = 3
Army2 = 3

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SpawnUnits("Enemy",Army)
	SpawnUnits("Enemy1",Army1)
    SetWinnable(false)	-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_5_1")
	AddTimer(4.0, removeText)
	AddTargetCircleWithArrow("win")
	AddTimer(4.0, EnableControls)
end

function EnableControls()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function removeText()
	HideDialog()
end

--removes dialog and adds combat buttons onto screen
function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

--sets the triggers in the level
function onLevelStart()
	ClearTargetCircles()
	SetTriggerCallbacks("fireballTrigger1", fireballTrigger1_onTriggerEnter, fireballTrigger1_onTriggerLeave)
	SetTriggerCallbacks("fireballTrigger2", fireballTrigger2_onTriggerEnter, fireballTrigger2_onTriggerLeave)
	SetTriggerCallbacks("fireballTrigger3", fireballTrigger3_onTriggerEnter, fireballTrigger3_onTriggerLeave)
	SetTriggerCallbacks("skeletonSpawn", skeletonSpawn_onTriggerEnter, skeletonSpawn_onTriggerLeave)
	SetTriggerCallbacks("win", win_onTriggerEnter, win_onTriggerLeave)
	AddTargetCircle("win")
	
end

--first trigger at opening of level
function fireballTrigger1_onTriggerEnter(unit)
	if unit.attacker then
		CastSpell("Fireball", 1, "fireball1",0)
		CastSpell("Fireball", 1, "fireball2",0)
		SpawnUnits("wave1",Army)
		AddTimer(1.5, wave1Run)
		DisableTrigger("fireballTrigger1")
	end
end

function wave1Run()
	GiveNamedUnitMoveOrder("wave1", "run1")
end

function fireballTrigger2_onTriggerEnter(unit)
	if unit.attacker then
		CastSpell("Fireball", 1, "fireball3",0)
		CastSpell("Fireball", 1, "fireball4",0)
		SpawnUnits("wave2",Army)
		AddTimer(2.5, wave2Run)
		DisableTrigger("fireballTrigger2")
	end
end

function wave2Run()
	GiveNamedUnitMoveOrder("wave2", "run2")
end

function fireballTrigger3_onTriggerEnter(unit)
	if unit.attacker then
		CastSpell("Fireball", 1, "fireball5",0)
		CastSpell("Fireball", 1, "fireball6",0)
		SpawnUnits("wave3",Army)
		AddTimer(2.5, wave3Run)
		DisableTrigger("fireballTrigger3")
	end
end

function wave3Run()
	GiveNamedUnitMoveOrder("wave3", "run3")
end

function skeletonSpawn_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("wave4",Army)
		DisableTrigger("skeletonSpawn")
	end
end

function win_onTriggerEnter(unit)
	if unit.attacker then
		Win()
	end
end

function createStartingTroops(forPlinthInspector)
		
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Enemy1",Army1)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
	end
end