-- calling out things we will need later in the script
destroyed = 0
SpellLevel = 8
Army = 10
Army1 = 10
Army2 = 10
Rank = 0
Titan = 14

-- calling out vfx that will be used throughout the level
function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

-- when deployment phase starts
function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
end

-- once the fight has begun (After user presses fight)
function onLevelStart()
    SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
end

-- On opening level camera complete
function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_10_1")
		
	end
end

-- This calls actions for the level to do upon certain talking heads being displayed
function onTalkingHeadFinish(text)
	if text == "TXT_CAMPAIGN_ELITHEN_10_1" then
		HideDialog()
		AddTimer(1, SpawnOnePlayerUnit)
		PlayVFX("PA_SpawnReinforcement", "elithen")
		PlayVFX("PA_SpawnReinforcement", "elithenleft")
		PlayVFX("PA_SpawnReinforcement", "elithenright")
		--ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_10_2")
		--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_10_3")
	end
end

-- Calls a spawn of a unit
function SpawnOnePlayerUnit()
	SpawnUnits("start6",Army)
end

-- actions to do once a defined unit is destroyed
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			RespawnUnits("start1", Army1)
			RespawnUnits("start2", Army1)
		end
		if destroyed == 10 then
		  --  ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_10_4")
			RespawnUnits("start3", Army2)
			RespawnUnits("start4", Army2)
		end
		if destroyed == 13 then
			--PlayVFX("PA_SpawnReinforcement", "airspawn")
			PlayVFX("PA_SpawnReinforcement", "airspawnleft")
			PlayVFX("PA_SpawnReinforcement", "airspawnright")
			AddTimer(1, SpawnOneEnemyUnit) 
		end
		if destroyed == 15 then
		    --ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_10_5")
		    PlayVFX("PA_SpawnReinforcement", "airtitan")
		    AddTimer(1, SpawnTitanEnemyUnit) 
			RespawnUnits("start1", Army1)		
		end
		if destroyed == 18 then
			--ShowDialogEternal("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_10_6")
			AddTimer(8.0,endgame)
            			
		end
	end
end

function SpawnOneEnemyUnit()
	SpawnUnits("start5",Army)
end

function SpawnTitanEnemyUnit()
	SpawnUnits("startTitan",Titan)
end

-- end game function that performs actions once triggered
function endgame()
    HideDialog()
	SetWinnable(true)
end

-- defines ranks, the units that need to be displayed at the beginning of the level.
function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 then			
			Army = Rank -3
			Army1 = Rank
			Titan = 6
		elseif Rank == 6 then			
			Army = Rank -3
			Army1 = Rank -1
			Titan = 8
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("start",Army)
	
	
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too as the player needs to know what they will be up against
		SpawnUnits("start1", Army)
		SpawnUnits("start2", Army)
		SpawnUnits("start3", Army1)
		SpawnUnits("start4", Army1)
		SpawnUnits("start5", Army)
		SpawnUnits("startTitan", Titan)
	end
end

