
RagnarSideRight = false

CreateRandomisedListOfThings("List_Spawn_Unit_IDs_Left","skeletonL1","skeletonL2","skeletonL3")
CreateRandomisedListOfThings("List_Spawn_Unit_IDs_Right","skeletonR1","skeletonR2","skeletonR3")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	
	ShowDialog("talkingheads/full/guard", "We need to stop this fighting, we have always been allies!")
	ShowDialog("talkingheads/full/Kobar", "The Ragnar are under attack from within, your help is not required.")
	
end


function onLevelStart()
	
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	
	SetEnemyPlayers(2,1)
	SetAlliedPlayers(2,0)
	
	if math.random() < 0.5 then
		RagnarSideRight = true
	else
		RagnarSideRight = false
	end
	
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		SpawnSkeletons(RagnarSideRight)
		HideDialog()
		ShowDialog("talkingheads/full/guard", "Something is teleporting in!")
		
		AddTimer(2,StartRagnarRunning)
		AddTimer(8,SpawnPlayerSideSkeletons)
	end
end

function StartRagnarRunning()
	
	HideDialog()
	ShowDialog("talkingheads/full/Kobar", "Not more of them!")
	
	if RagnarSideRight then
		GiveNamedUnitMoveOrder("[START]_RightRagnar", "RightCharge_RightRagnar")
		GiveNamedUnitMoveOrder("[START]_MiddleRagnar", "RightCharge_MiddleRagnar")
		GiveNamedUnitMoveOrder("[START]_LeftRagnar", "RightCharge_LeftRagnar")
	else
		GiveNamedUnitMoveOrder("[START]_RightRagnar", "LeftCharge_RightRagnar")
		GiveNamedUnitMoveOrder("[START]_MiddleRagnar", "LeftCharge_MiddleRagnar")
		GiveNamedUnitMoveOrder("[START]_LeftRagnar", "LeftCharge_LeftRagnar")
	end
end

function SpawnPlayerSideSkeletons()
	
	SpawnSkeletons(not RagnarSideRight)
	ShowDialog("talkingheads/full/Kobar", "There are more teleporting in on the other side, if you want to help you can take care of those.")
	
	AddTimer(4,MarkUnits,not RagnarSideRight)
	
end

function MarkUnits(sideToMarkRight)
	
	local skeletonsToMark = {}
	
	if sideToMarkRight then
		skeletonsToMark = GetUnits("*skeletonR*","*",1)
	else
		skeletonsToMark = GetUnits("*skeletonL*","*",1)
	end
	
	print(#skeletonsToMark)
	for i, unit in pairs(skeletonsToMark) do
		--ShowUnitGuideArrow(unit)
	end
	
end

function SpawnSkeletons(SpawnSideRight)

	if SpawnSideRight then
		for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_Right") do
			
			AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_Right"),true)
			
		end
	else
		for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_Left") do
			
			AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_Left"),true)
			
		end
	end
	
end


function onUnitDestroyed(unit)
	
	local enemyUnitsRemaining = GetUnits("*","*",1)
	if #enemyUnitsRemaining <= 0 then
		SpawnSkeletons()
	end
	
end


function SpawnUnitWithEffect(unit_ID, respawnNotSpawn)
	PlayVFX("PA_SpawnReinforcement", "Spawn_Effect_" .. unit_ID)
	
	if respawnNotSpawn then
		AddTimer(1,RespawnUnits,"unitSpawn_" .. unit_ID)
	else
		AddTimer(1,SpawnUnits,"unitSpawn_" .. unit_ID)
	end
end
