destroyed = 0
SpellLevel = 0
Army = 8
Army1 = 9
Army2 = 10
Titan = 10


function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SetTriggerCallbacks("spawn2", spawn2_onTriggerEnter)
	SetTriggerCallbacks("spawn3", spawn3_onTriggerEnter)
	SetTriggerCallbacks("spawn4", spawn4_onTriggerEnter)
	SetTriggerCallbacks("spawn5", spawn5_onTriggerEnter)
	SetTriggerCallbacks("spawn6a", spawn6a_onTriggerEnter)
	SetTriggerCallbacks("spawn6b", spawn6b_onTriggerEnter)
	SetTriggerCallbacks("spawn7", spawn7_onTriggerEnter)
	AddTimer(1,talkinghead)
end

function talkinghead()
	ShowDialogInPosition("talkingheads/full/erys","TXT_RANGERBAT_C2_M2_TH1","BOTTOM_LEFT")
	AddTimer(6.0,stoptalkinghead)
end

function stoptalkinghead()
	HideDialog()
end

function onLevelStart()
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
end

-- #1, #2, #3 below refers to the corridors player can pass through from the start point. 1 is the closest to the starting region
-- #1 Spawns Mossmane trio. center Ragnar, and Militia from upper left & middle rocks. Disables trigger spawn2
function spawn1_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX2a")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2b")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2c")
		AddTimer(.1,militiatop1)
		AddTimer(.1,militiamiddle1)
		AddTimer(1, mossmane1)
		AddTimer(3, ragnarcenter1)
		DisableTrigger("spawn1")
		DisableTrigger("spawn2")
		DisableTrigger("spawn7")
		framecamera1() -- because the mossmane spawn out of site, this quick cam cut shows them spawning in
	end
end

function framecamera1(seconds) 
	FrameCamera("spawnFX4")
	AddTimer(2, ReturnCamera)
	EnableCameraControl(false)
end

function mossmane1()
	SpawnUnits("mossmane",Army)
end

function militiatop1()
	SpawnUnits("militiatop",Army)
end

function militiamiddle1()
	SpawnUnits("militiamiddle",Army)
end

function ragnarcenter1()
	PlayVFX("PA_SpawnReinforcement", "spawnFX1")
	AddTimer(1,spawnragnarcenter1)
end

function spawnragnarcenter1()
	SpawnUnits("ragnarcenter",Army1)
end

-- #2 Spawns Mossmane trio. center Ragnar, and Militia from upper left rocks and bottom. Disables trigger spawn1
function spawn2_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX2a")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2b")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2c")
		AddTimer(.1,militiatop2)
		AddTimer(.1,militiabottom2)
		AddTimer(1, mossmane2)
		AddTimer(3, ragnarcenter2)	
		DisableTrigger("spawn2")
		DisableTrigger("spawn1")
		DisableTrigger("spawn7")
		framecamera2() -- because the mossmane spawn out of site, this quick cam cut shows them spawning in
	end
end

function framecamera2(seconds)
	FrameCamera("spawnFX4")
	AddTimer(3, ReturnCamera)
	EnableCameraControl(false)
end

function mossmane2()
	SpawnUnits("mossmane",Army)
end

function militiatop2()
	SpawnUnits("militiatop",Army)
end

function militiabottom2()
	SpawnUnits("militiabottom",Army)
end

function ragnarcenter2()
	PlayVFX("PA_SpawnReinforcement", "spawnFX1")
	AddTimer(1,spawnragnarcenter2)
end

function spawnragnarcenter2()
	SpawnUnits("ragnarcenter",Army1)
end

-- #3 Spawns Mossmane trio. center Ragnar, and Militia from middle left rocks and bottom. Disables trigger spawn1
function spawn7_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX2a")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2b")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2c")
--		AddTimer(.1,militiatop3) -- omitting as this would be too much of a backspawn... literally right behind the player troops
		AddTimer(.1,militiamiddle3)
		AddTimer(.1,militiabottom3)
		AddTimer(1, mossmane3)
		AddTimer(3, ragnarcenter3)	
		DisableTrigger("spawn2")
		DisableTrigger("spawn1")
		DisableTrigger("spawn7")
		framecamera3() -- because the mossmane spawn out of site, this quick cam cut shows them spawning in
	end
end

function framecamera3(seconds)
	FrameCamera("spawnFX4")
	AddTimer(3, ReturnCamera)
	EnableCameraControl(false)
end

function mossmane3()
	SpawnUnits("mossmane",Army)
end

--[[
function militiatop3()
	SpawnUnits("militiatop",Army)
end
--]]

function militiamiddle3()
	SpawnUnits("militiamiddle",Army)
end

function militiabottom3()
	SpawnUnits("militiabottom",Army)
end

function ragnarcenter3()
	PlayVFX("PA_SpawnReinforcement", "spawnFX1")
	AddTimer(1,spawnragnarcenter3)
end

function spawnragnarcenter3()
	SpawnUnits("ragnarcenter",Army1)
end

--[[
-- Spawns upper left Ragnar
function spawn3_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX3")
		AddTimer(1, spawn3)
		DisableTrigger("spawn3")
	end
end

function spawn3()
	SpawnUnits("spawn3",Army1)
end

-- Spawns upper right Ragnar
function spawn4_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX4")
		AddTimer(1, spawn4)
		DisableTrigger("spawn4")
	end
end

function spawn4()
	SpawnUnits("spawn4",Army1)
end
--]]

-- Spawns bottom Ragnar and disables spawn6b trigger
function spawn6a_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX6")
		AddTimer(1, spawn6)
		DisableTrigger("spawn6b")
		DisableTrigger("spawn6a")
	end
end

-- Spawns bottom Ragnar and disables spawn6a trigger
function spawn6b_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawnFX6")
		AddTimer(1, spawn6)
		DisableTrigger("spawn6b")
		DisableTrigger("spawn6a")
	end
end

function spawn6()
	SpawnUnits("spawn6",Army1)
end

-- Spawns Ranger baddie
function spawn5_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "rangerspawnFX")
		PlayVFX("PA_SpawnReinforcement", "rangerguardFX1")
		PlayVFX("PA_SpawnReinforcement", "rangerguardFX2")
		AddTimer(1, titanspawn)
		DisableTrigger("spawn5")
	end
end

function titanspawn() -- spawn the ranger titan
	SpawnUnits("titan",Titan)
	SpawnUnits("pikes",Army2)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 10 then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("mossmane",Army)
		SpawnUnits("militiatop",Army)
		SpawnUnits("militiamiddle",Army)
		SpawnUnits("ragnarcenter",Army1)
		SpawnUnits("spawn6",Army1)
		SpawnUnits("titan",Titan)
		SpawnUnits("pikes",Army2)
	end
end










