destroyed = 0
SpellLevel = 0
Army = 11
Army1 = 12
Army3 = 13
Titan = 18

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	PlayVFX("Elderstone_EnergyPropStones", "portalFX1")
	PlayVFX("Elderstone_EnergyPropStones", "portalFX2")
	PlayVFX("Elderstone_EnergyPropStones", "portalFX3")
	SpawnUnits("titan",Titan)
	SpawnUnits("unak",Army1)
	SpawnUnits("elithen",Army)
end

function onLevelStart()
	SetTriggerCallbacks("lefttrigger", lefttrigger_onTriggerEnter)
	SetTriggerCallbacks("righttrigger", righttrigger_onTriggerEnter)	
	SetTriggerCallbacks("toprighttrigger", toprighttrigger_onTriggerEnter) -- for the skell/archer/pikemen spawns
	SetTriggerCallbacks("toplefttrigger", toplefttrigger_onTriggerEnter) -- for the skell/militia/mossmane spawns
	SetTriggerCallbacks("SecondRight", SecondRight_onTriggerEnter) -- for the second wave militia from upper right
	SetTriggerCallbacks("SecondLeft", SecondLeft_onTriggerEnter) -- for the second wave militia from upper left
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
end

-- right skelleton, miliita, & mossmane spaawns
function righttrigger_onTriggerEnter(unit)
	if unit.attacker then	
		SpawnUnits("skelright",Army)
		AddTimer(1,spawnmilitiaFX)
		DisableTrigger("righttrigger")
	end
end

function spawnmilitiaFX()
	PlayVFX("PA_SpawnReinforcement", "militia1FX")
	PlayVFX("PA_SpawnReinforcement", "militia2FX")
	PlayVFX("PA_SpawnReinforcement", "militia3FX")
	AddTimer(1,spawnmilitia)
end

function spawnmilitia()
	SpawnUnits("militia",Army)
	SpawnUnits("mossmane",Army)
end

-- right 2nd wave militiaa
function SecondRight_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1,SecondRightFX)
		DisableTrigger("SecondRight")
	end
end

function SecondRightFX()
	PlayVFX("PA_SpawnReinforcement", "SecondRightFX")
	AddTimer(1,spawnSecondRight)
end

function spawnSecondRight()
	SpawnUnits("SecondRight",Army)
end

-- left skelleton and archer/pikemen spawns
function lefttrigger_onTriggerEnter(unit)
	if unit.attacker then	
		SpawnUnits("skelleft",Army)
		AddTimer(1,spawnarchpikeFX)
		DisableTrigger("lefttrigger")
	end
end

-- left 2nd wave militia
function SecondLeft_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1,SecondLeftFX)
		DisableTrigger("SecondLeft")
	end
end

function SecondLeftFX()
	PlayVFX("PA_SpawnReinforcement", "SecondLeftFX")
	AddTimer(1,spawnSecondLeft)
end

function spawnSecondLeft()
	SpawnUnits("SecondLeft",Army)
end

function spawnarchpikeFX()
	PlayVFX("PA_SpawnReinforcement", "archpike1FX")
	PlayVFX("PA_SpawnReinforcement", "archpike2FX")
	PlayVFX("PA_SpawnReinforcement", "archpike3FX")
	PlayVFX("PA_SpawnReinforcement", "archpike4FX")
	AddTimer(1,spawnarchpike)
end

function spawnarchpike()
	SpawnUnits("archpike",Army)
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 30 then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("unak",Army1)
		SpawnUnits("skelright",Army)
		SpawnUnits("militia",Army)
		SpawnUnits("skelleft",Army)
		SpawnUnits("archpike",Army)
		SpawnUnits("mossmane",Army)
		SpawnUnits("elithen",Army)
	end
end










