destroyed = 0
SpellLevel = 0
Army1 = 14
Army2 = 15
Army3 = 16
Titan = 14

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
end

function onLevelStart()
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SetTriggerCallbacks("spawn2", spawn2_onTriggerEnter)
	SetTriggerCallbacks("spawn3", spawn3_onTriggerEnter)
	SetTriggerCallbacks("spawn4", spawn4_onTriggerEnter)
	SetBattleTimeoutTime(360,0)  -- set battle timer for 5 minutes
end

-- spawns enemies at first portal disk
function spawn1_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "diskFX1")
		PlayVFX("PA_SpawnReinforcement", "spawnFX1")
		AddTimer(1,diskFX1)
		DisableTrigger("spawn1")
	end
end

function diskFX1()
	PlayVFX("Elderstone_EnergyPropStones", "diskFX1")
	SpawnUnits("spawn1", Army1)
end

-- spawns enemies at second portal disk
function spawn2_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "diskFX2")
		PlayVFX("PA_SpawnReinforcement", "spawnFX2")
		AddTimer(1,diskFX2)
		DisableTrigger("spawn2")
	end
end

function diskFX2()
	PlayVFX("Elderstone_EnergyPropStones", "diskFX2")
	SpawnUnits("spawn2", Army2)
end

-- spawns enemies at third and fourth portal disks
function spawn3_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "diskFX3")
		PlayVFX("PA_SpawnReinforcement", "diskFX4")
		PlayVFX("PA_SpawnReinforcement", "spawnFX3")
		PlayVFX("PA_SpawnReinforcement", "spawnFX4")
		AddTimer(1,diskFX3)
		DisableTrigger("spawn3")
	end
end

function diskFX3()
	PlayVFX("Elderstone_EnergyPropStones", "diskFX3")
	PlayVFX("Elderstone_EnergyPropStones", "diskFX4")
	SpawnUnits("spawn3", Army3)
end

-- starts the ambush phase of the mission with the fireballs burning down the trees and enemies spawning behind 
function spawn4_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.1,fireball1)
		AddTimer(3.0,fireball2)
		AddTimer(1.50,fireball3)
		AddTimer(2.40,fireball4)
		AddTimer(1.20,fireball5)
		AddTimer(1,spawnfinalFX)
		DisableTrigger("spawn4")
	end
end

-- fireball casting on forest
function fireball1()
	CastSpell("Fireball", 5, "fb1", 0)
end

function fireball2()
	CastSpell("Fireball", 5, "fb2", 0)
end

function fireball3()
	CastSpell("Fireball", 5, "fb3", 0)
end

function fireball4()
	CastSpell("Fireball", 5, "fb4", 0)
end

function fireball5()
	CastSpell("Fireball", 5, "fb5", 0)
	DisableTrigger("spawn4")
end

-- enemy ambush spawnFX behind burning trees
function spawnfinalFX()
	PlayVFX("PA_SpawnReinforcement", "finalFX1")
	PlayVFX("PA_SpawnReinforcement", "finalFX2")
	PlayVFX("PA_SpawnReinforcement", "finalFX3")
	PlayVFX("PA_SpawnReinforcement", "finalFX4")
	PlayVFX("PA_SpawnReinforcement", "finalFX5")
	PlayVFX("PA_SpawnReinforcement", "diskFX5")
	PlayVFX("PA_SpawnReinforcement", "diskFX6")
	AddTimer(1,spawnfinalFX)
end

-- enemy ambush spawns
function spawnfinalFX()
	SpawnUnits("final", Army2)
	PlayVFX("Elderstone_EnergyPropStones", "diskFX5")
	PlayVFX("Elderstone_EnergyPropStones", "diskFX6")
	AddTimer(1.00,spawntitanFX1)
	AddTimer(1.25,spawntitanFX2)
	AddTimer(1.50,spawntitanFX3)
	AddTimer(1.75,spawntitanFX4)
	AddTimer(2.00,spawntitanFX5)
end

function spawntitanFX1()
	PlayVFX("PA_SpawnReinforcement", "titanFX1")
end

function spawntitanFX2()
	PlayVFX("PA_SpawnReinforcement", "titanFX2")
end

function spawntitanFX3()
	PlayVFX("PA_SpawnReinforcement", "titanFX3")
end

function spawntitanFX4()
	PlayVFX("PA_SpawnReinforcement", "titanFX4")
end

-- titan spawning sequence
function spawntitanFX5()
	PlayVFX("PA_SpawnReinforcement", "titanFX5")
	PlayVFX("Elderstone_EnergyPropStones","portalFX1")
	PlayVFX("Elderstone_EnergyPropStones","portalFX2")
	PlayVFX("Elderstone_EnergyPropStones","portalFX3")
	AddTimer(1,spawntitan)
end

function spawntitan()
	SpawnUnits("titan",Titan)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 20	then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end 

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn1", Army1)
		SpawnUnits("spawn2", Army2)
		SpawnUnits("spawn3", Army3)
		SpawnUnits("final", Army2)
		SpawnUnits("titan",Titan)
	end
end










