destroyed = 0
SpellLevel = 0
Army = 17
Army1 = 18
Army2 = 19

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	
	AddTargetCircle("circle") -- indicates to player to hang out around the center 
	SpawnUnits("start",Army)
end

function onLevelStart()
	SetTriggerCallbacks("circle", circle_onTriggerEnter)
	SetBattleTimeoutTime(420,0)  -- set battle timer for 7 minutes
end

-- camera intro to show the center of the map
function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1,framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("cam")
	AddTimer(4, ReturnCamera)
	EnableCameraControl(false)
end

function circle_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(4,spawn12FX)
		DisableTrigger("circle")
	end
end

-- spawning enemies around the clock, counerclockwise
-- starting with 12 O'clock enemies
function spawn12FX()
	PlayVFX("PA_SpawnReinforcement", "12FX") -- 12:00
	AddTimer(1,spawn12)
end
	
function spawn12()
	SpawnUnits("12",Army) -- 12:00
end

-- subsequent "o'clock" enemies spawned based on previous deaths
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
			if destroyed == 4 then
				AddTimer(1,tenfx) -- 10:00
			end
			if destroyed == 6 then
				AddTimer(1,eightfx) -- 8:00
			end
			if destroyed == 8 then
				AddTimer(1,sixfx) -- 6:00
			end
			if destroyed == 11 then
				AddTimer(1,fourfx) -- 4:00
			end
			if destroyed == 14 then
				AddTimer(1,twofx) -- 2:00
			end
			if destroyed == 18 then
				AddTimer(1,rangerFX1)			
			end
			if destroyed == 30 then
				AddTimer(5,win)
		end
	end
end

-- 10 O'clock enemies
function tenfx()
	PlayVFX("PA_SpawnReinforcement", "10FX")
	AddTimer(1,spawn10)
end

function spawn10()
	SpawnUnits("10",Army)
end

-- 8 O'clock enemies
function eightfx()
	PlayVFX("PA_SpawnReinforcement", "8FX")
	AddTimer(1,spawn8)
end

function spawn8()
	SpawnUnits("8",Army1)
end

-- 6 O'clock enemies
function sixfx()
	PlayVFX("PA_SpawnReinforcement", "6FX")
	AddTimer(1,spawn6)
end

function spawn6()
	SpawnUnits("6",Army1)
end

-- 4 O'clock enemies
function fourfx()
	PlayVFX("PA_SpawnReinforcement", "4FX")
	AddTimer(1,spawn4)
end

function spawn4()
	SpawnUnits("4",Army2)
	SpawnUnits("4rag",Army)
end

-- 2 O'clock enemies
function twofx()
	PlayVFX("PA_SpawnReinforcement", "2FX")
	AddTimer(1,spawn2)
end

function spawn2()
	SpawnUnits("2",Army2)
end

-- ranger spawn -NOTE, no more ranger spaawn
--[[
function rangerFX()
	PlayVFX("PA_SpawnReinforcement", "circle")
end


function spawnRanger()
	SpawnUnits("ranger",Titan)
end
--]]

-- repurposesd these FX for final enemy spawns and mossmane ally reinforcement
function rangerFX1()
--	AddTimer(1.1,rangerFX)
	AddTimer(1.2,rangerFX2)
	AddTimer(1.3,rangerFX3)
	AddTimer(1.4,rangerFX4)
	AddTimer(1.5,rangerFX5)
	AddTimer(1.6,rangerFX6)
	AddTimer(1.8,rangerFX7)
	AddTimer(30,moss1FX) -- 30 second delay is the wait time for the "rescue" sequence from the mossmane
	AddTimer(30,moss2FX)
	AddTimer(30,moss3FX)
	AddTimer(30,moss4FX)
	AddTimer(30,moss5FX)
	AddTimer(30,moss6FX)
--	AddTimer(1,rangerFX8)		
end

function rangerFX2()
	PlayVFX("PA_SpawnReinforcement", "rangerFX7")	
	AddTimer(1,spawnRanger1)
end

function rangerFX3()
	PlayVFX("PA_SpawnReinforcement", "rangerFX8")	
	AddTimer(1,spawnRanger2)
end	

function rangerFX4()
	PlayVFX("PA_SpawnReinforcement", "rangerFX9")
	AddTimer(1,spawnRanger3)	
end

function rangerFX5()
	PlayVFX("PA_SpawnReinforcement", "rangerFX10")
	AddTimer(1,spawnRanger4)	
end

function rangerFX6()
	PlayVFX("PA_SpawnReinforcement", "rangerFX11")
	AddTimer(1,spawnRanger5)	
end

function rangerFX7()
	PlayVFX("PA_SpawnReinforcement", "rangerFX13")
	AddTimer(1,spawnRanger6)		
end
--[[
function rangerFX8()
	PlayVFX("PA_SpawnReinforcement", "rangerFX12")	
	AddTimer(1,spawnRanger)
end
--]]

function spawnRanger1()
	SpawnUnits("ranger1",Army2)
end

function spawnRanger2()
	SpawnUnits("ranger2",Army2)
end

function spawnRanger3()
	SpawnUnits("ranger3",Army2)
end

function spawnRanger4()
	SpawnUnits("ranger4",Army2)
end

function spawnRanger5()
	SpawnUnits("ranger5",Army2)
end

function spawnRanger6()
	SpawnUnits("ranger6",Army2)
end

-- spawn mossmane ally rescuers
function moss1FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX1")	
	AddTimer(1,spawnmoss1)
end

function moss1FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX1")	
	AddTimer(1,spawnmoss1)
end

function moss2FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX2")	
	AddTimer(1,spawnmoss2)
end

function moss3FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX3")	
	AddTimer(1,spawnmoss3)
end

function moss4FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX4")	
	AddTimer(1,spawnmoss4)
end

function moss5FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX5")	
	AddTimer(1,spawnmoss5)
end

function moss6FX()
	PlayVFX("PA_SpawnReinforcement", "rangerFX6")	
	AddTimer(1,spawnmoss6)
end

function spawnmoss1()
	SpawnUnits("moss1",Army)
end

function spawnmoss2()
	SpawnUnits("moss2",Army)
end

function spawnmoss3()
	SpawnUnits("moss3",Army)
end

function spawnmoss4()
	SpawnUnits("moss4",Army)
end

function spawnmoss5()
	SpawnUnits("moss5",Army)
end

function spawnmoss6()
	SpawnUnits("moss6",Army)
end

function win()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("12",Army)
		SpawnUnits("10",Army)
		SpawnUnits("8",Army1)
		SpawnUnits("6",Army1)
		SpawnUnits("4",Army2)
		SpawnUnits("4rag",Army)
		SpawnUnits("2",Army2)
		SpawnUnits("ranger1",Army2)
		SpawnUnits("ranger2",Army2)
		SpawnUnits("ranger3",Army2)
		SpawnUnits("ranger4",Army2)
		SpawnUnits("ranger5",Army2)
end

function spawnRanger6()
	SpawnUnits("ranger6",Army2)
	end
end










