destroyed = 0
SpellLevel = 0
Army = 19
Army1 = 20
Army2 = 21
Titan = 28

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(False)
	SpawnUnits("start",Army)
end

function onLevelStart()
	SetTriggerCallbacks("right1", right1_onTriggerEnter)
	SetTriggerCallbacks("left1", left1_onTriggerEnter)
	SetTriggerCallbacks("right2", right2_onTriggerEnter)
	SetTriggerCallbacks("left2", left2_onTriggerEnter)
	SetTriggerCallbacks("portalright", portalright_onTriggerEnter)
	SetTriggerCallbacks("portalleft", portalleft_onTriggerEnter)
	SetTriggerCallbacks("spawn7", spawn7_onTriggerEnter)
	AddTimer(1,mossmane1FX) -- first mossmane spawns from the bottom of map
	AddTimer(1,mossmane2FX)
	SetBattleTimeoutTime(360,0)  -- set battle timer for 6 minutes
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			AddTimer(1,mossmane3FX) -- start second mossmane spawns from the bottom of map
			AddTimer(1,mossmane4FX)
		end
		if destroyed == 16 then -- all are killed except one of the side spawns (militia/archers) and final spawns
			AddTimer(1,camera)
		end
		if destroyed == 21 then
			AddTimer(3.0,endgame)
		end
	end
end

-- mossmane 1 and 2 spawns, first mossmane pair spawns from the bottom of the map
function mossmane1FX()
	PlayVFX("PA_SpawnReinforcement", "mossmane1FX")
	AddTimer(1,spawnmoss1)
end

function spawnmoss1()
	SpawnUnits("mossmane1",Army)
end

function mossmane2FX()
	PlayVFX("PA_SpawnReinforcement", "mossmane2FX")
	AddTimer(1,spawnmoss2)
end

function spawnmoss2()
	SpawnUnits("mossmane2",Army)
end

-- mossmane 3 and 4 spawns, these spawns sneak up on the player after the frist two mossmanes are dead
function mossmane3FX()
	PlayVFX("PA_SpawnReinforcement", "mossmane3FX")
	AddTimer(1,spawnmoss3)
end

function spawnmoss3()
	SpawnUnits("mossmane3",Army1)
end

function mossmane4FX()
	PlayVFX("PA_SpawnReinforcement", "mossmane4FX")
	AddTimer(1,spawnmoss4)
end

function spawnmoss4()
	SpawnUnits("mossmane4",Army1)
end

-- right side trigger spawns from the top
function right1_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,right1FX)
		DisableTrigger("right1")
		DisableTrigger("right2")
	end
end

function right1FX()
	PlayVFX("PA_SpawnReinforcement", "right1FX")
	PlayVFX("PA_SpawnReinforcement", "right2FX")
	AddTimer(1,spawnright)
end

function spawnright()
	SpawnUnits("right",Army2)
end

-- left side trigger spawns from the top
function left1_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,left1FX)
		DisableTrigger("left1")
		DisableTrigger("left2")
	end
end

function left1FX()
	PlayVFX("PA_SpawnReinforcement", "left1FX")
	PlayVFX("PA_SpawnReinforcement", "left2FX")
	AddTimer(1,spawnleft)
end

function spawnleft()
	SpawnUnits("left",Army2)
end

-- right side spawns from the bottom, if you went the left side first
function right2_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,right2FX)
		DisableTrigger("right1")
		DisableTrigger("right2")
	end
end

function right2FX()
	PlayVFX("PA_SpawnReinforcement", "right1FX")
	PlayVFX("PA_SpawnReinforcement", "right2FX")
	AddTimer(1,spawnright2)
end

function spawnright2()
	SpawnUnits("right",Army2)
end

-- left side spawns from the bottom, if you went the right side first
function left2_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,left2FX)
		DisableTrigger("left1")
		DisableTrigger("left2")
	end
end

function left2FX()
	PlayVFX("PA_SpawnReinforcement", "left1FX")
	PlayVFX("PA_SpawnReinforcement", "left2FX")
	AddTimer(1,spawnleft2)
end

function spawnleft2()
	SpawnUnits("left",Army2)
end

-- right side bottom spawns, spawns guys at the disk
function portalright_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,portalrightFX)
		DisableTrigger("portalright")
		DisableTrigger("portalleft")
	end
end

function portalrightFX()
	PlayVFX("PA_SpawnReinforcement", "portalright1FX")
	PlayVFX("PA_SpawnReinforcement", "portalright2FX")
--	PlayVFX("PA_SpawnReinforcement", "titanFX")	
	AddTimer(1,spawnportalright)
end

function spawnportalright()
	SpawnUnits("portalright",Army2)
	SpawnUnits("portalleft",Army2)
--	SpawnUnits("titan",Army1)
end

-- left side bottom spawns, spawns same guys at the disk as if you came from the right, no doubling up of spawns
function portalleft_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,portalleftFX)
		DisableTrigger("portalright")
		DisableTrigger("portalleft")
	end
end

function portalleftFX()
	PlayVFX("PA_SpawnReinforcement", "portalleft1FX")
	PlayVFX("PA_SpawnReinforcement", "portalleft2FX")
--	PlayVFX("PA_SpawnReinforcement", "titanFX")	
	AddTimer(1,spawnportalleft)
end

function spawnportalleft()
	SpawnUnits("portalright",Army2)
	SpawnUnits("portalleft",Army2)
--	SpawnUnits("titan",Army1)
end

function camera(seconds) 
	FrameCamera("camera")
	AddTimer(4, ReturnCamera)
	EnableCameraControl(false)
	AddTimer(.5,titanFX)
end

function titanFX()
	PlayVFX("PA_SpawnReinforcement", "titanFX")	
--	PlayVFX("PA_SpawnReinforcement", "titanwallFX1")	
--	PlayVFX("PA_SpawnReinforcement", "titanwallFX2")
	PlayVFX("PA_SpawnReinforcement", "titanwallFX3")
	PlayVFX("PA_SpawnReinforcement", "titanwallFX4")
	AddTimer(1,spawntitan)
end

function spawntitan()
	SpawnUnits("titan",Titan)
	SpawnUnits("titanwall",Army1)
end

function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("mossmane1",Army)
		SpawnUnits("mossmane2",Army)
		SpawnUnits("mossmane3",Army1)
		SpawnUnits("mossmane4",Army1)
		SpawnUnits("right",Army2)
		SpawnUnits("left",Army2)
		SpawnUnits("portalright",Army2)
		SpawnUnits("portalleft",Army2)	
		SpawnUnits("titan",Titan)
		SpawnUnits("titanwall",Army2)
	end
end










