destroyed = 0
SpellLevel = 0
Army = 22
Army1 = 23
Army2 = 24
Army3 = 25
Titan = 35

-- NOTE: this mission had gone over it's limit of 32 trigger regions. 
-- Had to scale by quite a bit to bring under 32 

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("start",Army) -- couple of enemies just inside fort to lure player in
	SetWinnable(false)	-- no enemies start in the mission, win set to false
end

function onLevelStart()
	SetTriggerCallbacks("walltrigger1", walltrigger1_onTriggerEnter)
	SetTriggerCallbacks("spawnfirsttrigger", spawnfirsttrigger_onTriggerEnter)
	SetTriggerCallbacks("walltrigger2", walltrigger2_onTriggerEnter)
	SetTriggerCallbacks("walltrigger3", walltrigger3_onTriggerEnter)
	SetTriggerCallbacks("spawnsecondtrigger", spawnsecondtrigger_onTriggerEnter)
	SetTriggerCallbacks("finalspawn", finalspawn_onTriggerEnter)
	SetBattleTimeoutTime(360,0)  -- set battle timer for 6 minutes
end

-- first fireball gate
function walltrigger1_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1.0,fireball1)
		AddTimer(3.0,fireball2)
		AddTimer(1.5,fireball3)
		AddTimer(2.4,fireball4)
		DisableTrigger("walltrigger1")
	end
end

function fireball1()
	CastSpell("Fireball", 5, "fb1", 0)
end

function fireball2()
	CastSpell("Fireball", 5, "fb2", 0)
end

function fireball3()
	CastSpell("Fireball", 5, "fb3", 0)
end

function fireball4()
	CastSpell("Fireball", 5, "fb4", 0)
end

-- spawn first enemy group at first wall, timed a second after each fireball
function spawnfirsttrigger_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(3.5,first1FX)
		AddTimer(5.0,first2FX)
		AddTimer(3.75,first3FX)
		AddTimer(4.4,first4FX)
		AddTimer(4.75,first5FX)
		AddTimer(5.0,first6FX)
		DisableTrigger("spawnfirsttrigger")
	end
end

function first1FX()
	PlayVFX("PA_SpawnReinforcement", "first1FX")
	AddTimer(1,spawnfirst1)
end

function spawnfirst1()
	SpawnUnits("first1",Army)
end

function first2FX()
--	PlayVFX("PA_SpawnReinforcement", "first2FX")
	AddTimer(1,spawnfirst2)
end

function spawnfirst2()
	SpawnUnits("first2",Army)
end

function first3FX()
--	PlayVFX("PA_SpawnReinforcement", "first3FX")
	AddTimer(1,spawnfirst3)
end

function spawnfirst3()
	SpawnUnits("first3",Army)
end

function first4FX()
	PlayVFX("PA_SpawnReinforcement", "first4FX")
	AddTimer(1,spawnfirst4)
end

function spawnfirst4()
	SpawnUnits("first4",Army)
end

function first5FX()
	PlayVFX("PA_SpawnReinforcement", "first5FX")
	AddTimer(1,spawnfirst5)
end

function spawnfirst5()
	SpawnUnits("first5",Army)
end

function first6FX()
--	PlayVFX("PA_SpawnReinforcement", "first6FX")
	AddTimer(1,spawnfirst6)
end

function spawnfirst6()
	SpawnUnits("first6",Army)
end

-- second wall/fireball explodies
function walltrigger2_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.1,fireball5)
		AddTimer(3.0,fireball6)
		AddTimer(1.50,fireball7)
		AddTimer(2.40,fireball8)
		DisableTrigger("walltrigger2")
	end
end

function fireball5()
	CastSpell("Fireball", 5, "fb5", 0)
end

function fireball6()
	CastSpell("Fireball", 5, "fb6", 0)
end

function fireball7()
	CastSpell("Fireball", 5, "fb7", 0)
end

function fireball8()
	CastSpell("Fireball", 5, "fb8", 0)
	DisableTrigger("walltrigger2")
end

-- spawn second enemy group (skellies) at second gate
function spawnsecondtrigger_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(3.5,second1FX)
		AddTimer(5.0,second2FX)
		AddTimer(3.75,second3FX)
		AddTimer(4.4,second4FX)
		AddTimer(4.75,second5FX)
		AddTimer(5.0,second6FX)
		DisableTrigger("spawnsecondtrigger")
	end
end

function second1FX()
--	PlayVFX("PA_SpawnReinforcement", "second1FX")
	AddTimer(1,spawnsecond1)
end

function spawnsecond1()
	SpawnUnits("second1",Army1)
end

function second2FX()
--	PlayVFX("PA_SpawnReinforcement", "second2FX")
	AddTimer(1,spawnsecond2)
end

function spawnsecond2()
	SpawnUnits("second2",Army1)
end

function second3FX()
--	PlayVFX("PA_SpawnReinforcement", "second3FX")
	AddTimer(1,spawnsecond3)
end

function spawnsecond3()
	SpawnUnits("second3",Army1)
end

function second4FX()
--	PlayVFX("PA_SpawnReinforcement", "second4FX")
	AddTimer(1,spawnsecond4)
end

function spawnsecond4()
	SpawnUnits("second4",Army1)
end

function second5FX()
--	PlayVFX("PA_SpawnReinforcement", "second5FX")
	AddTimer(1,spawnsecond5)
end

function spawnsecond5()
	SpawnUnits("second5",Army1)
end

function second6FX()
--	PlayVFX("PA_SpawnReinforcement", "second6FX")
	AddTimer(1,spawnsecond6)
end

function spawnsecond6()
	SpawnUnits("second6",Army1)
end

-- third fireball gate
function walltrigger3_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.1,fireball9)
		AddTimer(3.0,fireball10)
		AddTimer(1.50,fireball11)
		AddTimer(2.40,fireball12)
		AddTimer(.1,prefinalFX)
		DisableTrigger("walltrigger3")
	end
end

function prefinalFX()
	PlayVFX("PA_SpawnReinforcement", "ally1FX")
	AddTimer(1,prefinalspawn)
end

function prefinalspawn()
	SpawnUnits("prefinal",Army3)
end

function fireball9()
	CastSpell("Fireball", 5, "fb9", 0)
end

function fireball10()
	CastSpell("Fireball", 5, "fb10", 0)
end

function fireball11()
	CastSpell("Fireball", 5, "fb11", 0)
end

function fireball12()
	CastSpell("Fireball", 5, "fb12", 0)
	DisableTrigger("walltrigger3")
end

-- final spawn event
function finalspawn_onTriggerEnter(unit)
	if unit.attacker then
		FrameCamera("enemycam")
		AddTimer(4,ReturnCamera)
		AddTimer(1,finalspawnFX)
		EnableCameraControl(false)
		AddTimer(85,cavalry)
		DisableTrigger("finalspawn")
	end
end

function finalspawnFX()
		PlayVFX("PA_SpawnReinforcement", "finalspawn1FX")
		PlayVFX("PA_SpawnReinforcement", "finalspawn2FX")
		PlayVFX("PA_SpawnReinforcement", "finalspawn3FX")
--		PlayVFX("PA_SpawnReinforcement", "finalspawn4FX")
--		PlayVFX("PA_SpawnReinforcement", "finalspawn5FX")
		PlayVFX("PA_SpawnReinforcement", "titanFX")
		AddTimer(1,finalspawn)
end

function finalspawn()
	SpawnUnits("final",Army3)
	SpawnUnits("titan",Titan)
end

function cavalry(seconds)
	FrameCamera("allycam")
	AddTimer(3,ReturnCamera)
	AddTimer(1,allyspawnFX)
	EnableCameraControl(false)
	AddTimer(1,talkinghead)
end

function talkinghead()
	ShowDialogInPosition("talkingheads/full/guard","TXT_RANGERBAT_C3_M4_TH1","BOTTOM_LEFT")
	AddTimer(5,stoptalkinghead)
end

function stoptalkinghead()
	HideDialog()
end

function allyspawnFX()
	PlayVFX("PA_SpawnReinforcement", "ally1FX")
	PlayVFX("PA_SpawnReinforcement", "ally2FX")
	PlayVFX("PA_SpawnReinforcement", "ally3FX")
--	PlayVFX("PA_SpawnReinforcement", "ally4FX")
	PlayVFX("PA_SpawnReinforcement", "ally5FX")
	AddTimer(1,allyspawn)
	AddTimer(4.00,mossspawn1FX)
	AddTimer(4.25,mossspawn2FX)
	AddTimer(4.50,mossspawn3FX)
end

function allyspawn()
	SpawnUnits("ally",Army)
end

-- mossmane reinforcements
function mossspawn1FX()
--	PlayVFX("PA_SpawnReinforcement", "goodmoss1FX")
	AddTimer(1,mossspawn1)
end

function mossspawn1()
	SpawnUnits("moss1",Army)
end

function mossspawn2FX()
--	PlayVFX("PA_SpawnReinforcement", "goodmoss2FX")
	AddTimer(1,mossspawn2)
end

function mossspawn2()
	SpawnUnits("moss2",Army)
end

function mossspawn3FX()
--	PlayVFX("PA_SpawnReinforcement", "goodmoss3FX")
	AddTimer(1,mossspawn3)
end

function mossspawn3()
	SpawnUnits("moss3",Army)
end
	
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 29 then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
--	Win()
	SetWinnable(true)
	AddTimer(1,endforreals)
end

function endforreals()
	Win()
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("first1",Army)
		SpawnUnits("first2",Army)
		SpawnUnits("first3",Army)
		SpawnUnits("first4",Army)
		SpawnUnits("first5",Army)
		SpawnUnits("first6",Army)
		SpawnUnits("second1",Army1)
		SpawnUnits("second2",Army1)
		SpawnUnits("second3",Army1)
		SpawnUnits("second4",Army1)
		SpawnUnits("second5",Army1)
		SpawnUnits("second6",Army1)
		SpawnUnits("prefinal",Army3)
		SpawnUnits("final",Army3)
		SpawnUnits("titan",Titan)
	end
end










